//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.bc_chat.im.activity;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.bc_chat.bc_base.utils.Const;
import com.bc_chat.im.R;
import com.google.zxing.BinaryBitmap;
import com.google.zxing.ChecksumException;
import com.google.zxing.DecodeHintType;
import com.google.zxing.FormatException;
import com.google.zxing.NotFoundException;
import com.google.zxing.RGBLuminanceSource;
import com.google.zxing.Result;
import com.google.zxing.common.HybridBinarizer;
import com.google.zxing.qrcode.QRCodeReader;
import com.zhaohaoting.framework.utils.Check;
import com.zhaohaoting.framework.utils.ToastUtils;
import com.zhaohaoting.framework.utils.observer.ObserverManager;

import java.io.File;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import io.rong.common.FileUtils;
import io.rong.common.RLog;
import io.rong.eventbus.EventBus;
import io.rong.imageloader.core.DisplayImageOptions;
import io.rong.imageloader.core.DisplayImageOptions.Builder;
import io.rong.imageloader.core.ImageLoader;
import io.rong.imageloader.core.assist.FailReason;
import io.rong.imageloader.core.assist.ImageScaleType;
import io.rong.imageloader.core.assist.ImageSize;
import io.rong.imageloader.core.listener.ImageLoadingListener;
import io.rong.imageloader.core.listener.ImageLoadingProgressListener;
import io.rong.imkit.R.drawable;
import io.rong.imkit.R.id;
import io.rong.imkit.R.string;
import io.rong.imkit.RongBaseNoActionbarActivity;
import io.rong.imkit.RongIM;
import io.rong.imkit.plugin.image.HackyViewPager;
import io.rong.imkit.utilities.OptionsPopupDialog;
import io.rong.imkit.utilities.PermissionCheckUtil;
import io.rong.imkit.utilities.RongUtils;
import io.rong.imkit.utils.ImageDownloadManager;
import io.rong.imkit.utils.ImageDownloadManager.DownloadStatusError;
import io.rong.imkit.utils.ImageDownloadManager.DownloadStatusListener;
import io.rong.imlib.RongCommonDefine.GetMessageDirection;
import io.rong.imlib.RongIMClient;
import io.rong.imlib.RongIMClient.ErrorCode;
import io.rong.imlib.RongIMClient.OperationCallback;
import io.rong.imlib.RongIMClient.ResultCallback;
import io.rong.imlib.destruct.DestructionTaskManager;
import io.rong.imlib.destruct.DestructionTaskManager.OnOverTimeChangeListener;
import io.rong.imlib.destruct.MessageBufferPool;
import io.rong.imlib.model.Conversation.ConversationType;
import io.rong.imlib.model.Message;
import io.rong.imlib.model.Message.MessageDirection;
import io.rong.message.DestructionCmdMessage;
import io.rong.message.ImageMessage;
import io.rong.subscaleview.ImageSource;
import io.rong.subscaleview.SubsamplingScaleImageView;

public class PicturePagerActivity extends RongBaseNoActionbarActivity implements OnLongClickListener {
    private static final String TAG = "PicturePagerActivity";
    private static final int IMAGE_MESSAGE_COUNT = 10;
    private HackyViewPager mViewPager;
    private ImageMessage mCurrentImageMessage;
    private Message mMessage;
    private ConversationType mConversationType;
    private int mCurrentMessageId;
    private String mTargetId = null;
    private int mCurrentIndex = 0;
    private PicturePagerActivity.ImageAdapter mImageAdapter;
    private boolean isFirstTime = false;
    private OnPageChangeListener mPageChangeListener = new OnPageChangeListener() {
        public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
        }

        public void onPageSelected(int position) {
            RLog.i("PicturePagerActivity", "onPageSelected. position:" + position);
            PicturePagerActivity.this.mCurrentIndex = position;
            View view = PicturePagerActivity.this.mViewPager.findViewById(position);
            if (view != null) {
                PicturePagerActivity.this.mImageAdapter.updatePhotoView(position, view);
            }

            if (position == PicturePagerActivity.this.mImageAdapter.getCount() - 1) {
                PicturePagerActivity.this.getConversationImageUris(PicturePagerActivity.this.mImageAdapter.getItem(position).getMessageId().getMessageId(), GetMessageDirection.BEHIND);
            } else if (position == 0) {
                PicturePagerActivity.this.getConversationImageUris(PicturePagerActivity.this.mImageAdapter.getItem(position).getMessageId().getMessageId(), GetMessageDirection.FRONT);
            }

        }

        public void onPageScrollStateChanged(int state) {
        }
    };

    public PicturePagerActivity() {
    }

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.setContentView(R.layout.rc_fr_photo);
        Message currentMessage = (Message) this.getIntent().getParcelableExtra("message");
        this.mMessage = currentMessage;
        this.mCurrentImageMessage = (ImageMessage) currentMessage.getContent();
        this.mConversationType = currentMessage.getConversationType();
        this.mCurrentMessageId = currentMessage.getMessageId();
        this.mTargetId = currentMessage.getTargetId();
        this.mViewPager = (HackyViewPager) this.findViewById(id.viewpager);
        this.mViewPager.setOnPageChangeListener(this.mPageChangeListener);
        this.mImageAdapter = new PicturePagerActivity.ImageAdapter();
        this.isFirstTime = true;
        this.getConversationImageUris(this.mCurrentMessageId, GetMessageDirection.FRONT);
        this.getConversationImageUris(this.mCurrentMessageId, GetMessageDirection.BEHIND);
    }

    private void getConversationImageUris(int mesageId, final GetMessageDirection direction) {
        if (this.mConversationType != null && !TextUtils.isEmpty(this.mTargetId)) {
            RongIMClient.getInstance().getHistoryMessages(this.mConversationType, this.mTargetId, "RC:ImgMsg", mesageId, 10, direction, new ResultCallback<List<Message>>() {
                public void onSuccess(List<Message> messages) {
                    ArrayList<PicturePagerActivity.ImageInfo> lists = new ArrayList();
                    if (messages != null) {
                        if (direction.equals(GetMessageDirection.FRONT)) {
                            Collections.reverse(messages);
                        }

                        for (int i = 0; i < messages.size(); ++i) {
                            Message message = (Message) messages.get(i);
                            if (message.getContent() instanceof ImageMessage) {
                                ImageMessage imageMessage = (ImageMessage) message.getContent();
                                Uri largeImageUri = imageMessage.getLocalUri() == null ? imageMessage.getRemoteUri() : imageMessage.getLocalUri();
                                if (imageMessage.getThumUri() != null && largeImageUri != null) {
                                    lists.add(PicturePagerActivity.this.new ImageInfo(message, imageMessage.getThumUri(), largeImageUri));
                                }
                            }
                        }
                    }

                    if (direction.equals(GetMessageDirection.FRONT) && PicturePagerActivity.this.isFirstTime) {
                        lists.add(PicturePagerActivity.this.new ImageInfo(PicturePagerActivity.this.mMessage, PicturePagerActivity.this.mCurrentImageMessage.getThumUri(), PicturePagerActivity.this.mCurrentImageMessage.getLocalUri() == null ? PicturePagerActivity.this.mCurrentImageMessage.getRemoteUri() : PicturePagerActivity.this.mCurrentImageMessage.getLocalUri()));
                        PicturePagerActivity.this.mImageAdapter.addData(lists, direction.equals(GetMessageDirection.FRONT));
                        PicturePagerActivity.this.mViewPager.setAdapter(PicturePagerActivity.this.mImageAdapter);
                        PicturePagerActivity.this.isFirstTime = false;
                        PicturePagerActivity.this.mViewPager.setCurrentItem(lists.size() - 1);
                        PicturePagerActivity.this.mCurrentIndex = lists.size() - 1;
                    } else if (lists.size() > 0) {
                        PicturePagerActivity.this.mImageAdapter.addData(lists, direction.equals(GetMessageDirection.FRONT));
                        PicturePagerActivity.this.mImageAdapter.notifyDataSetChanged();
                        if (direction.equals(GetMessageDirection.FRONT)) {
                            PicturePagerActivity.this.mViewPager.setCurrentItem(lists.size());
                            PicturePagerActivity.this.mCurrentIndex = lists.size();
                        }
                    }

                }

                public void onError(ErrorCode e) {
                }
            });
        }

    }

    protected void onPause() {
        super.onPause();
    }

    protected void onDestroy() {
        super.onDestroy();
        DestructionTaskManager.getInstance().removeListeners("PicturePagerActivity");
    }

    public boolean onPictureLongClick(View v, Uri thumbUri, Uri largeImageUri) {
        return false;
    }

    public boolean onLongClick(View v) {
        PicturePagerActivity.ImageInfo imageInfo = this.mImageAdapter.getImageInfo(this.mCurrentIndex);
        if (imageInfo != null) {
            Uri thumbUri = imageInfo.getThumbUri();
            Uri largeImageUri = imageInfo.getLargeImageUri();
            if (this.onPictureLongClick(v, thumbUri, largeImageUri)) {
                return true;
            }

            if (largeImageUri == null) {
                return false;
            }

            final File file;
            if (!largeImageUri.getScheme().startsWith("http") && !largeImageUri.getScheme().startsWith("https")) {
                file = new File(largeImageUri.getPath());
            } else {
                file = ImageLoader.getInstance().getDiskCache().get(largeImageUri.toString());
            }
            new DecodeBitmapTask(new WeakReference<>(this)).execute(file);
        }
        return true;
    }

    private static void showPopupDialog(File file, String qrCode, WeakReference<Activity> activity) {
        String[] items;
        if (Check.isEmpty(qrCode)) {
            items = new String[]{"保存图片"};
        } else {
            items = new String[]{"保存图片", "识别图中二维码"};
        }
        OptionsPopupDialog.newInstance(activity.get(), items).setOptionsPopupDialogListener(which -> {
            if (which == 0) {
                String[] permissions = new String[]{"android.permission.READ_EXTERNAL_STORAGE", "android.permission.WRITE_EXTERNAL_STORAGE"};
                if (!PermissionCheckUtil.requestPermissions(activity.get(), permissions)) {
                    return;
                }

                String saveImagePath = RongUtils.getImageSavePath(activity.get());
                if (file != null && file.exists()) {
                    String name = System.currentTimeMillis() + ".jpg";
                    FileUtils.copyFile(file, saveImagePath + File.separator, name);
                    MediaScannerConnection.scanFile(activity.get(), new String[]{saveImagePath + File.separator + name}, null, null);
                    ToastUtils.show(activity.get().getString(R.string.rc_save_picture_at));
                } else {
                    ToastUtils.show(activity.get().getString(R.string.rc_src_file_not_found));
                }
            } else {
                ObserverManager.getInstance().notifyObserver(Const.ObserverKey.SCANNER_QRCODE, qrCode);
            }

        }).show();
    }

    private static class DecodeBitmapTask extends AsyncTask<File, Integer, Result> {
        private File file;

        public DecodeBitmapTask(WeakReference<Activity> activity) {
            this.activity = activity;
        }

        WeakReference<Activity> activity;

        @Override
        protected Result doInBackground(File... files) {
            file = files[0];
            if (file == null || !file.exists()) {
                return null;
            } else {
                return scanningImage(file.getPath());
            }
        }

        @Override
        protected void onPostExecute(Result result) {
            if (result == null || Check.isEmpty(result.getText())) {
                showPopupDialog(file, null, activity);
            } else {
                showPopupDialog(file, result.getText(), activity);
            }
        }
    }

    protected static Result scanningImage(String path) {
        if (TextUtils.isEmpty(path)) {
            return null;
        }
        // DecodeHintType 和EncodeHintType
        Hashtable<DecodeHintType, String> hints = new Hashtable<DecodeHintType, String>();
        hints.put(DecodeHintType.CHARACTER_SET, "utf-8"); // 设置二维码内容的编码
        BitmapFactory.Options options = new BitmapFactory.Options();
        options.inJustDecodeBounds = true; // 先获取原大小
        BitmapFactory.decodeFile(path, options);
        int outHeight = options.outHeight;
        int sampleSize = (int) (outHeight / (float) 700);

        if (sampleSize <= 0)
            sampleSize = 1;
        options.inSampleSize = sampleSize;
        options.inJustDecodeBounds = false; // 获取新的大小
        Bitmap scanBitmap = BitmapFactory.decodeFile(path, options);
        int width = scanBitmap.getWidth();
        int height = scanBitmap.getHeight();
        final int[] pixels = new int[width * height];
        scanBitmap.getPixels(pixels, 0, width, 0, 0, width, height);
        RGBLuminanceSource source = new RGBLuminanceSource(width, height, pixels);
        BinaryBitmap bitmap1 = new BinaryBitmap(new HybridBinarizer(source));
        QRCodeReader reader = new QRCodeReader();
        try {
            return reader.decode(bitmap1, hints);
        } catch (NotFoundException e) {
            e.printStackTrace();
        } catch (ChecksumException e) {
            e.printStackTrace();
        } catch (FormatException e) {
            e.printStackTrace();
        }
        return null;
    }


    private class ImageInfo {
        private Message message;
        private Uri thumbUri;
        private Uri largeImageUri;

        ImageInfo(Message message, Uri thumbnail, Uri largeImageUri) {
            this.message = message;
            this.thumbUri = thumbnail;
            this.largeImageUri = largeImageUri;
        }

        public Message getMessageId() {
            return this.message;
        }

        public Uri getLargeImageUri() {
            return this.largeImageUri;
        }

        public Uri getThumbUri() {
            return this.thumbUri;
        }
    }

    private class ImageAdapter extends PagerAdapter {
        private ArrayList<PicturePagerActivity.ImageInfo> mImageList;

        private ImageAdapter() {
            this.mImageList = new ArrayList();
        }

        private View newView(Context context, PicturePagerActivity.ImageInfo imageInfo) {
            View result = LayoutInflater.from(context).inflate(R.layout.rc_fr_image, (ViewGroup) null);
            PicturePagerActivity.ImageAdapter.ViewHolder holder = new PicturePagerActivity.ImageAdapter.ViewHolder();
            holder.progressBar = (ProgressBar) result.findViewById(R.id.rc_progress);
            holder.progressText = (TextView) result.findViewById(R.id.rc_txt);
            holder.photoView = (SubsamplingScaleImageView) result.findViewById(R.id.rc_photoView);
            holder.mCountDownView = (TextView) result.findViewById(R.id.rc_count_down);
            holder.photoView.setOnLongClickListener(PicturePagerActivity.this);
            holder.photoView.setOnClickListener(new OnClickListener() {
                public void onClick(View v) {
                    PicturePagerActivity.this.finish();
                }
            });
            result.setTag(holder);
            return result;
        }

        public void addData(ArrayList<PicturePagerActivity.ImageInfo> newImages, boolean direction) {
            if (newImages != null && newImages.size() != 0) {
                if (this.mImageList.size() == 0) {
                    this.mImageList.addAll(newImages);
                } else if (direction && !PicturePagerActivity.this.isFirstTime && !this.isDuplicate(((PicturePagerActivity.ImageInfo) newImages.get(0)).getMessageId().getMessageId())) {
                    ArrayList<PicturePagerActivity.ImageInfo> temp = new ArrayList();
                    temp.addAll(this.mImageList);
                    this.mImageList.clear();
                    this.mImageList.addAll(newImages);
                    this.mImageList.addAll(this.mImageList.size(), temp);
                } else if (!PicturePagerActivity.this.isFirstTime && !this.isDuplicate(((PicturePagerActivity.ImageInfo) newImages.get(0)).getMessageId().getMessageId())) {
                    this.mImageList.addAll(this.mImageList.size(), newImages);
                }

            }
        }

        private boolean isDuplicate(int messageId) {
            Iterator var2 = this.mImageList.iterator();

            PicturePagerActivity.ImageInfo info;
            do {
                if (!var2.hasNext()) {
                    return false;
                }

                info = (PicturePagerActivity.ImageInfo) var2.next();
            } while (info.getMessageId().getMessageId() != messageId);

            return true;
        }

        public PicturePagerActivity.ImageInfo getItem(int index) {
            return (PicturePagerActivity.ImageInfo) this.mImageList.get(index);
        }

        public int getItemPosition(Object object) {
            return -2;
        }

        public int getCount() {
            return this.mImageList.size();
        }

        public boolean isViewFromObject(View view, Object object) {
            return view == object;
        }

        public Object instantiateItem(ViewGroup container, int position) {
            RLog.i("PicturePagerActivity", "instantiateItem.position:" + position);
            View imageView = this.newView(container.getContext(), (PicturePagerActivity.ImageInfo) this.mImageList.get(position));
            this.updatePhotoView(position, imageView);
            imageView.setId(position);
            container.addView(imageView);
            return imageView;
        }

        public void destroyItem(ViewGroup container, int position, Object object) {
            RLog.i("PicturePagerActivity", "destroyItem.position:" + position);
            container.removeView((View) object);
        }

        private void updatePhotoView(final int position, View view) {
            final PicturePagerActivity.ImageAdapter.ViewHolder holder = (PicturePagerActivity.ImageAdapter.ViewHolder) view.getTag();
            Uri originalUri = ((PicturePagerActivity.ImageInfo) this.mImageList.get(position)).getLargeImageUri();
            final Uri thumbUri = ((PicturePagerActivity.ImageInfo) this.mImageList.get(position)).getThumbUri();
            if (originalUri != null && thumbUri != null) {
                File file = ImageLoader.getInstance().getDiskCache().get(originalUri.toString());
                if (file != null && file.exists()) {
                    Uri resultUri = Uri.fromFile(file);
                    if (!resultUri.equals(holder.photoView.getUri())) {
                        holder.photoView.setImage(ImageSource.uri(resultUri));
                    }

                } else {
                    DisplayImageOptions options = (new Builder()).cacheInMemory(true).cacheOnDisk(true).imageScaleType(ImageScaleType.NONE).bitmapConfig(Config.RGB_565).considerExifParams(true).build();
                    ImageLoader.getInstance().loadImage(originalUri.toString(), (ImageSize) null, options, new ImageLoadingListener() {
                        public void onLoadingStarted(String imageUri, View view) {
                            holder.photoView.setImage(ImageSource.uri(thumbUri));
                            holder.progressText.setVisibility(View.VISIBLE);
                            holder.progressBar.setVisibility(View.VISIBLE);
                            holder.progressText.setText("0%");
                        }

                        public void onLoadingFailed(String imageUri, View view, FailReason failReason) {
                            if (imageUri.startsWith("file://")) {
                                holder.progressText.setVisibility(View.GONE);
                                holder.progressBar.setVisibility(View.GONE);
                            } else {
                                ImageDownloadManager.getInstance().downloadImage(imageUri, new DownloadStatusListener() {
                                    public void downloadSuccess(String localPath, Bitmap bitmap) {
                                        holder.photoView.setImage(ImageSource.uri(localPath));
                                        holder.progressText.setVisibility(View.GONE);
                                        holder.progressBar.setVisibility(View.GONE);
                                    }

                                    public void downloadFailed(DownloadStatusError error) {
                                        holder.progressText.setVisibility(View.GONE);
                                        holder.progressBar.setVisibility(View.GONE);
                                    }
                                });
                            }

                        }

                        public void onLoadingComplete(String imageUri, View view, Bitmap loadedImage) {
                            ImageAdapter.this.sendDestructingMsg(PicturePagerActivity.this.mMessage);
                            ImageAdapter.this.handleDestructionImage(position, holder);
                            holder.progressText.setVisibility(View.GONE);
                            holder.progressBar.setVisibility(View.GONE);
                            File file = ImageLoader.getInstance().getDiskCache().get(imageUri);
                            Uri resultUri = null;
                            if (file != null) {
                                resultUri = Uri.fromFile(file);
                            }

                            holder.photoView.setBitmapAndFileUri(loadedImage, resultUri);
                            View inPagerView = PicturePagerActivity.this.mViewPager.findViewById(position);
                            if (inPagerView != null) {
                                PicturePagerActivity.ImageAdapter.ViewHolder inPagerHolder = (PicturePagerActivity.ImageAdapter.ViewHolder) inPagerView.getTag();
                                if (inPagerHolder != holder) {
                                    inPagerHolder.progressText.setVisibility(View.GONE);
                                    inPagerHolder.progressBar.setVisibility(View.GONE);
                                    PicturePagerActivity.this.mImageAdapter.updatePhotoView(position, inPagerView);
                                }
                            }

                        }

                        public void onLoadingCancelled(String imageUri, View view) {
                            holder.progressText.setVisibility(View.GONE);
                            holder.progressText.setVisibility(View.GONE);
                        }
                    }, new ImageLoadingProgressListener() {
                        public void onProgressUpdate(String imageUri, View view, int current, int total) {
                            holder.progressText.setText(current * 100 / total + "%");
                            if (current == total) {
                                holder.progressText.setVisibility(View.GONE);
                                holder.progressBar.setVisibility(View.GONE);
                            } else {
                                holder.progressText.setVisibility(View.GONE);
                                holder.progressBar.setVisibility(View.GONE);
                            }

                        }
                    });
                    this.handleDestructionImage(position, holder);
                }
            } else {
                RLog.e("PicturePagerActivity", "large uri and thumbnail uri of the image should not be null.");
            }
        }

        private void sendDestructingMsg(Message message) {
            if (message.getContent().isDestruct() && message.getMessageDirection() == MessageDirection.RECEIVE && message.getReadTime() <= 0L && !TextUtils.isEmpty(message.getUId())) {
                long currentTimeMillis = System.currentTimeMillis();
                RongIMClient.getInstance().setMessageReadTime((long) message.getMessageId(), currentTimeMillis, (OperationCallback) null);
                message.setReadTime(currentTimeMillis);
                DestructionCmdMessage destructionCmdMessage = new DestructionCmdMessage();
                destructionCmdMessage.addBurnMessageUId(message.getUId());
                MessageBufferPool.getInstance().putMessageInBuffer(Message.obtain(message.getTargetId(), message.getConversationType(), destructionCmdMessage));
                EventBus.getDefault().post(message);
            }

        }

        private void handleDestructionImage(int position, final PicturePagerActivity.ImageAdapter.ViewHolder holder) {
            final Message message = ((PicturePagerActivity.ImageInfo) this.mImageList.get(position)).message;
            if (message.getContent().isDestruct() && message.getReadTime() > 0L) {
                holder.mCountDownView.setVisibility(View.VISIBLE);
                RongIM.getInstance().createDestructionTask(PicturePagerActivity.this.mMessage, new OnOverTimeChangeListener() {
                    public void onOverTimeChanged(final int messageId, final long leftTime) {
                        holder.mCountDownView.post(new Runnable() {
                            public void run() {
                                if (messageId == message.getMessageId()) {
                                    if (leftTime <= 30L) {
                                        holder.mCountDownView.setBackgroundResource(drawable.rc_count_down_preview_count);
                                        holder.mCountDownView.setText(PicturePagerActivity.this.getResources().getString(string.rc_time_count_down, new Object[]{leftTime}));
                                    } else {
                                        holder.mCountDownView.setBackgroundResource(drawable.rc_count_down_preview_no_count);
                                    }

                                    if (leftTime <= 0L) {
                                        String toast = PicturePagerActivity.this.getResources().getString(string.rc_toast_message_destruct);
                                        ToastUtils.show(toast);
                                        PicturePagerActivity.this.finish();
                                    }

                                }
                            }
                        });
                    }

                    public void onMessageDestruct(int messageId) {
                    }
                }, "PicturePagerActivity");
            } else {
                holder.mCountDownView.setVisibility(View.GONE);
            }

        }

        public PicturePagerActivity.ImageInfo getImageInfo(int position) {
            return (PicturePagerActivity.ImageInfo) this.mImageList.get(position);
        }

        public class ViewHolder {
            ProgressBar progressBar;
            TextView progressText;
            SubsamplingScaleImageView photoView;
            TextView mCountDownView;

            public ViewHolder() {
            }
        }
    }
}
